commit 2cbd82044b21679fa533445f373374576f638da1
Author: liuhongt <hongtao.liu@intel.com>
Date:   Tue Aug 11 11:05:40 2020 +0800

    Refine expander vec_unpacku_float_hi_v16si/vec_unpacku_float_lo_v16si
    
    gcc/
            PR target/96551
            * config/i386/sse.md (vec_unpacku_float_hi_v16si): For vector
            compare to integer mask, don't use gen_rtx_LT, use
            ix86_expand_mask_vec_cmp instead.
            (vec_unpacku_float_hi_v16si): Ditto.
    
    gcc/testsuite
            * gcc.target/i386/avx512f-pr96551-1.c: New test.
            * gcc.target/i386/avx512f-pr96551-2.c: New test.

diff --git a/gcc/testsuite/gcc.target/i386/avx512f-pr96551-1.c b/gcc/testsuite/gcc.target/i386/avx512f-pr96551-1.c
new file mode 100644
index 00000000000..598bb6e85f3
--- /dev/null
+++ b/gcc/testsuite/gcc.target/i386/avx512f-pr96551-1.c
@@ -0,0 +1,18 @@
+/* { dg-do compile } */
+/* { dg-options "-O2 -mavx512f -mprefer-vector-width=512" } */
+
+unsigned int a[256];
+double b[256];
+
+void
+__attribute__ ((noipa, optimize ("tree-vectorize")))
+foo(void)
+{
+  int i;
+
+  for (i=0; i<256; ++i)
+    b[i] = a[i];
+}
+
+/* { dg-final { scan-assembler "vcvtdq2pd\[^\n\]*zmm" } } */
+
diff --git a/gcc/testsuite/gcc.target/i386/avx512f-pr96551-2.c b/gcc/testsuite/gcc.target/i386/avx512f-pr96551-2.c
new file mode 100644
index 00000000000..f8bb1da7966
--- /dev/null
+++ b/gcc/testsuite/gcc.target/i386/avx512f-pr96551-2.c
@@ -0,0 +1,33 @@
+/* { dg-do run } */
+/* { dg-options "-O2 -mavx512f -mprefer-vector-width=512" } */
+/* { dg-require-effective-target avx512f } */
+
+#ifndef CHECK
+#define CHECK "avx512f-helper.h"
+#endif
+
+#include CHECK
+
+#ifndef TEST
+#define TEST test_512
+#endif
+
+#include "avx512f-pr96551-1.c"
+
+void
+test_512 (void)
+{
+  double exp[256];
+  for (int i = 0; i != 256; i++)
+    {
+      a[i] = i * i + 3 * i + 13;
+      exp[i] = a[i];
+      b[i] = 0;
+    }
+
+  foo ();
+
+  for (int i = 0; i != 256; i++)
+    if (exp[i] != b[i])
+      abort ();
+}

